/*
 * File: ppp.cc
 * Date: November 14, 2003
 * Author: Vikas Paliwal
 * Email: vpaliwal@sce.carleton.ca
 * Implementation for a passing agent between a node and its RLP entity
 */

#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "ip.h"
#include "ppp.h"
#include "rlp.h"
#include "rtp.h"
#include "node.h"
#include "connector.h"

#include <iostream.h>

static class PppClass : public TclClass
{
	public:
		PppClass() : TclClass("Agent/Ppp")
		{
		}
	    TclObject* create(int, const char*const*)
	    {
		    return (new PppAgent());
	    }
} class_ppp;


PppAgent::PppAgent() : Agent(PT_PPP)
{
 // bind_offset(&hdr_rlp::off_rlp_);
  //bind_offset(&hdr_rlp::off_rtp_);
}


int PppAgent::command(int argc, const char*const* argv)
{
  if (argc == 3)
  {
    if (strcmp(argv[1], "dst") == 0)
    {
   	    Agent* a = (Agent*)TclObject::lookup(argv[2]);
		dst=a;
		return (TCL_OK);
    }
    if (strcmp(argv[1], "destnode") == 0)
    {
   	    Node* a = (Node*)TclObject::lookup(argv[2]);
	    destIP = a->address();
		return (TCL_OK);
    }
  }
  return (Agent::command(argc, argv));
}


void PppAgent::recv(Packet* pkt, Handler*)
{
  hdr_cmn* hdrcmn = hdr_cmn::access(pkt);
  if(hdrcmn->ptype() != PT_RLP)
  {
    dst->recv(pkt,(Handler*)0);
  }
  else
  {
    hdr_rlp* hdra = hdr_rlp::access(pkt);
    hdr_cmn* header_common_ = hdr_cmn::access(pkt);
    header_common_->ptype() = hdra->packet_type_;
    hdr_ip* hdrip = hdr_ip::access(pkt);
    //hdrip->dst() = dst_;
    send(pkt,0);
  }
}
